[English](https://github.com/KazushiMe/Switch-OC-Suite/blob/master/README.md) | **简体中文**

# Switch 超频套件

Mariko Switch（续航版/Lite）超频套件，仅支持 Atmosphere CFW。

**暂未更新文档**

注意：为方便中文用户反馈，中文讨论请移步至 Switch 超频交流 QQ 群：884865516



## 功能

- **仅限 Mariko 机型：**

  - 绕过 Horizon OS 的限制，将 CPU/GPU 的频率提升至 2397/1344 MHz

    - 当 CPU 频率 ≥ 2295 MHz 或者 GPU 频率 ≥ 1305.6 MHz 时进入增压超频模式，但某些 SoC 在加压时不稳定

    - 在超满且不插电的情况下，Mariko Switch 仍能正常工作，故解除 sys-clk 对频率的限制，但别太贪心

  - 游戏启动与加载时自动提升 CPU 频率（可选）

    - 不插电情况下 1963.5 MHz，插电情况下 2295.0 MHz

    - 有些游戏不使用 SetCpuBoostMode，比如说 Overcooked 2，则加载时自动提升频率失效

  - 优化高温下的风扇控制

- 提供 Erista 和 Mariko 机型的内存超频：目前，Erista 机型可在加压情况下使用 1862.4/2131.2 MHz，Mariko 机型暂时无法加压，可使用 1731.2/1862.4/1996.8 MHz

  - 内存频率始终固定在你应用补丁时选择的频率，但由此增加的功耗可忽略不计，故移除 sys-clk 中设置内存频率的功能，改用 ptm 内存补丁

  - 对于 Mariko 机型：

    - 海力士内存推荐频率为 1731.2 MHz（xx海力士），对于三星和镁光的内存，可以使用更高频率： 1862.4/1993.6 MHz

    - 使用 Hekate 以确认内存厂商

  - 对于 Erista 机型：

    - 使用 Hekate 启动时，Minerva 模块 (`/bootloader/sys/libsys_minerva.bso`) 需要被移除或者[修改](https://github.com/CTCaer/hekate/blob/master/modules/hekate_libsys_minerva/sys_sdrammtc.c#L31)后重新编译

    - 内存电压设置在 1150 mV @ 1862.4 MHz 或者 1200 mV @ 2131.2 MHz，可能会出现死机、不稳定的情况，那么需要尝试其他电压 (HOS 默认：1125 mV)，通过[手动修补 pcv 模块](#手动修补 pcv 模块)或者重新编译 loader.kip 实现

- 禁用部分后台服务，降低待机模式耗电量

- 与 ReverseNX(-Tools 和 -RT) 同步模式，切换模式后无需再进入 sys-clk 调整频率

- 可对所有游戏设置固定频率，且区分模式

- 游戏录制与 SysDVR 串流 60 fps 与高比特率模式（可选）

  - 相册里的录制时长为实际值的两倍，但播放速度不受影响

  - 如果使用高比特率模式，可能无法录制到 30 秒

  - 对性能要求高的游戏，可能会降低游戏性能

- 移除截图/游戏录制中的版权水印，并绕过联网验证 ctest，由 [HookedBehemoth](https://github.com/HookedBehemoth/exefs_patches) 提供



## 安装

### 方法一：整合包

#### 目前发布的整合包已移除受版权保护的 pcv 模块（及其“补丁”）

#### 请等待后续更新，将提供自行修改 pcv 模块的方法

#### 注意，除非[自行编译 Atmosphere](#方法二：自行编译)，只有已修改的 pcv 模块才能实现超频

**包含:**

- Pcv 模块修补，附带 ptm 内存补丁

- 预编译的 sys-clk 和 ReverseNX-RT，已为超频优化

- 对 Horizon OS 的一些改进补丁

**缺点:**

- 系统文件被修改，你**不能**在 SysNAND 上打了补丁的情况下启动到 Stock(OFW) 系统，除非将其复原，且存在被 ban 风险 (?)，所以不推荐将补丁应用至 SysNAND

**步骤:**

1. 确保你使用的是指定的 HOS 版本，且已用  [Lockpick_RCM](https://github.com/shchmue/Lockpick_RCM) 导出  `prod.keys`

2. 在 [release](https://github.com/KazushiMe/Switch-OC-Suite/releases) 下载整合包，将 `SdOut` 里的所有文件放入 SD 卡中

   - 注意 `/atmosphere/config/system_settings.ini` 文件，你可能需要进行修改而非直接替换，详情参见[使用与自定义](#使用与自定义)

   - 更新前请删除上一版本的文件，避免冲突

3. ???

4. 从 hekate 加载 [TegraExplorer](https://github.com/suchmememanyskill/TegraExplorer/releases/latest) payload

5. 选择 `Browse SD` -> `patcher.te` (EmuNAND) 或者 `patcher_sysmmc.te` (SysNAND) -> `Launch Script`.

6. 等待 `Done!` 出现，重启

**⚠️警告与已知问题:⚠️**

- **在更新 Horizon OS 或者启动 OFW 之前，必须还原 pcv 模块备份**。




### 方法二：自行编译

以下命令仅供参考

```bash
git clone https://github.com/KazushiMe/Switch-OC-Suite.git ~/Switch-OC-Suite

cd $YOUR_ATMOSPHERE_REPO
cp -R ~/Switch-OC-Suite/Atmosphere/*pp stratosphere/loader/source/
patch < ~/Switch-OC-Suite/Atmosphere/ldr_patcher.diff

cd $YOUR_SYS_CLK_REPO
git apply ~/Switch-OC-Suite/sys-clk.diff

cd $YOUR_REVERSENX_RT_REPO
git apply ~/Switch-OC-Suite/ReverseNX-RT.diff
```

自行安装 devkitpro 并编译 sys-clk、ReverseNX-RT 和 Atmosphere，并加入必要的补丁

如果你不想浪费时间，编译 Atmosphere 的 `loader.kip`，并用 hekate 加载

已应用补丁的  [sys-clk](https://github.com/KazushiMe/sys-clk)、 [ReverseNX-RT](https://github.com/KazushiMe/ReverseNX-RT) repo



## 使用与自定义

**system_settings.ini**，在 `/atmosphere/config/` 里

- **对于 Erista 机型：**

  - 删除 "Fan Control for Mariko"

- 如果你使用任天堂在线服务，比如好友、在线存档和通知，移除 "disable services" 的部分

- 对于 "Game Recording FPS and Bitrate"，如果你玩对性能要求高的游戏，或者不在乎串流/录制帧率/画质，注释掉这一部分

**sys-clk**

- **对于 Mariko 机型：**

  - 如果想在游戏加载屏幕中思考人生，删除  `/config/sys-clk/boost.flag` 文件

  - 如果想感受 CD 时期游戏启动有多慢，删除 `/config/sys-clk/boost_start.flag`

- 添加 `/config/sys-clk/downclock_dock.flag` 文件，当 ReverseNX 设置了掌机模式时，底座模式下则使用掌机模式的频率

- 在`/config/sys-clk/config.ini` 中添加 `[A111111111111111]`，对所有游戏设置频率，区分模式：

  ```ini
  [A111111111111111]
  docked_cpu=
  docked_gpu=
  handheld_charging_cpu=
  handheld_charging_gpu=
  handheld_charging_usb_cpu=
  handheld_charging_usb_gpu=
  handheld_charging_official_cpu=
  handheld_charging_official_gpu=
  handheld_cpu=
  handheld_gpu=
  ```



### 手动修补 pcv 模块

1. 获取 [hactool](https://github.com/SciresM/hactool)、[nx2elf](https://github.com/shuffle2/nx2elf)、[switch-tools](https://github.com/switchbrew/switch-tools/)、[hacPack](https://github.com/The-4n/hacPack)、 `prod.keys`，Hex 编辑器或者最好是逆向工具

2. 找到 pcv 模块并提取 exefs：

   ```bash
   for NCA_FILE in $HOME/12.0.2/*.nca
   do
   	[[ $NCA_FILE == *".cnmt.nca" ]] && continue
   	titleid=`hactool -k prod.keys --disablekeywarns -t -nca $NCA_FILE | grep 'Title ID'`
   	if [[ $titleid == *"010000000000001a"* ]]; then
   		echo $NCA_FILE
   		hactool -k prod.keys --disablekeywarns -t -nca $NCA_FILE --exefsdir $HOME/pcvout/
   		break
   	fi
   done
   ```

3. 转换 main(nso) 为 main.elf：

   ```bash
   nx2elf $HOME/pcvout/main
   ```

4. 使用逆向工具或者 Hex 编辑器（需要重新计算偏移）修补，[偏移参考](https://github.com/KazushiMe/Switch-OC-Suite/blob/master/Atmosphere/ldr_pcv_patch.cpp)

   用 Hex 编辑器修补内存电压：找到 `88 2A 11 00`（1125000 uV，小端），替换找到的两个结果

5. 使用 switch-tools 中的 elf2nso 转回 nso：

   ```bash
   elf2nso $HOME/pcvout/main.elf $HOME/pcvout/main
   ```

6. 使用伪签名重新打包程序 nca：

   ```bash
   hacpack -k prod.keys -o $HOME/pcvmod/ --type nca --ncatype program --titleid 010000000000001A --exefsdir $HOME/pcvout/
   ```

   修补好的 pcv 模块在 `$HOME/pcvmod/` 里，文件名随机



## 致谢

- CTCaer：Hekate 引导修改，逆向及硬件研究

- HookedBehemoth：nifm_ctest 及 am_no_copyright [补丁](https://github.com/HookedBehemoth/exefs_patches)

- masagrator： [ReverseNX-RT](https://github.com/masagrator/ReverseNX-RT)

- RetroNX 团队： [sys-clk](https://github.com/retronx-team/sys-clk) 和提供讨论 [的地方](https://*discord*.*gg*/erNC4FB)

- SciresM：Switch 最先进的自制系统 [Atmosphere](https://github.com/Atmosphere-NX/Atmosphere)

- suchmememanyskill：[TegraExplorer](https://github.com/suchmememanyskill/TegraExplorer) 和 [TegraScript](https://github.com/suchmememanyskill/TegraScript)

- Switchbrew [wiki](http://switchbrew.org/wiki/)： Switch 深度信息

- ZatchyCatGames：逆向和原始超频补丁



